declare('killshot', {})

local function dofile2(file_name, dir)
	dir = dir or 'killshot'
	local file,err_msg = loadfile(file_name) 
	if not file and err_msg:find('No such file or directory') then file,err_msg = loadfile('plugins/'..dir..'/'..file_name) end
	if file then 
		return file()
	else
		error(err_msg)
	end
end

local Config = dofile2'Config.lua'
local ProcessCommand = dofile2'ProcessCommand.lua'

killshot.debug = false
killshot.conf = Config{
	name = 'killshot',
	version = '1.2',
	{var_name = 'on', type = 'boolean', default = true, is_main = true, custom_msg = true, on_msg = 'killshot is on', off_msg = 'killshot is off'},
	{var_name = 'idie', type = 'boolean', default = false, desc = 'Take screenshots when you are killed'},
	{var_name = 'ikill', type = 'boolean', default = true, desc = 'Take screenshots when you kill someone'},
	{var_name = 'bots', type = 'boolean', default = false, desc = 'Take screenshots when bots are involved'},
	{var_name = 'issue', type = 'boolean', default = false, desc = 'Take screenshots when you kill yourself'},
	{var_name = 'firstshot', type = 'boolean', default = true, desc = 'Take screenshots at the exact moment when you kill someone (will likely show him just about to die, ie. not yet dead'},
	{var_name = 'secondshot', type = 'boolean', default = true, desc = 'Take sreenshots short time after you kill someone (will likely show his explosion and then kill text)'},
	{var_name = 'secondshotdelay', type = 'number', default = 300, desc = 'How long after the kill to take second screenshot, in miliseconds'},
	{var_name = 'selfkilldelay', type = 'boolean', default = 500, hidden = true},
	{var_name = 'sendkillmsg', type = 'boolean', default = false, desc = 'Whether to send a message after you kill someone'},
	{var_name = 'killmsg', type = 'boolean', default = 'Smile for the camera!', desc = 'Message to send after you kill someone'},
	{var_name = 'custom_file_name', type = 'boolean', default = true, desc = 'Whether to use default file names or one specified by file_name_format'},
	{var_name = 'file_name_format', type = 'string', default = '<killer> kills <victim>-<no>', 
		desc = 'Custom file naming format, tags will be replaced with: killer, victim - name, no - 1 or 2 (first or second shot).\n\tCurrent date and time and file extension (.png) will always be appended at the end (to prevent name conflicts)'},
	{var_name = 'use_folder', type = 'boolean', default = false, desc = 'Whether to save screenshots to a specified folder'},
	{var_name = 'folder', type = 'string', default = 'killshots', desc = 'You can specify just a name or path relative to base vo directory eg. "screenshots\\killshots\\", all folders must already exist or nothing will be saved.'},
}
function killshot.print(...)
	if killshot.debug then print(...) end
end

function killshot.make_file_name(victim, killer, no)
	local file_name
	if killshot.conf.custom_file_name then
		file_name = FindAndReplaceTags(killshot.conf.file_name_format, {victim = GetPlayerName(victim), killer = GetPlayerName(killer), no = no})
		local datetime = os.date'%d-%m-%y %H-%M-%S'
		file_name = ('%s %s.png'):format(file_name, datetime)
	end
	if killshot.conf.use_folder then
		local folder = killshot.conf.folder:gsub('^[\\/]', ''):gsub('[\\/]$', '') -- should move that to validation function in config i think
		file_name = folder..'/'..file_name
	end
	return file_name
end

function killshot.dump(victim, killer)
	if killshot.conf.firstshot then
		ProcessCommand('dump', killshot.make_file_name(victim, killer, 1))
	end
	if killshot.conf.secondshot and victim~=killer then
		Timer():SetTimeout(killshot.conf.secondshotdelay, function()
			ProcessCommand('dump', killshot.make_file_name(victim, killer, 2))
		end)
	end
end

function killshot.is_bot(charid)
	if GetPlayerName(charid):sub(1,1)=='*' then
		return true
	else 
		return false
	end
end
local is_bot = killshot.is_bot

function killshot:PLAYER_DIED(ev, victim, killer)
	if killshot.conf.on then
		if victim==killer then
			killshot.print('issue')
			if killshot.conf.issue then
				killshot.print('issue - taking pic')
				Timer():SetTimeout(killshot.conf.selfkilldelay, function() killshot.dump(victim, killer) end)
			end
		else
			killshot.print'not issue'
			if GetPlayerName(victim)==GetPlayerName() then -- you got killed
				killshot.print'you died'
				if killshot.conf.idie and (not is_bot(killer) or killshot.conf.bots) then
					killshot.print'you died - taking pic'
					killshot.dump(victim, killer)
				end
			else -- you killed someone
				killshot.print'you killed'
				if killshot.conf.ikill and (not is_bot(victim) or killshot.conf.bots) then
					killshot.print'you killed - taking pic'
					killshot.dump(victim, killer)
					if killshot.conf.sendkillmsg and not is_bot(victim) then
						SendChat(killshot.conf.killmsg, 'PRIVATE', GetPlayerName(victim))
					end
				end
			end
		end
 	end 
end
RegisterEvent(killshot, 'PLAYER_DIED')